﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript">

        document._moveFocus = function(isBackward)
        {
            var options = {
                isBackward: isBackward,
                currentFocus: this._focus,
                isSearching: !this._focus
            }
            try
            {
                this._focusSearch(this, options);
                document._focus = document;
            } catch (e)
            {
                if (e != options) throw e;
                e.result.focus();
            }
        }

        document._focusSearch = function(node, options)
        {
            var isBackward = options.isBackward
            if (!this.isBackward) this._focusSearchCheckNode(node, options)
            var children = node.childNodes
            for (var i = 0; i < children.length; i++)
            {
                var index = isBackward ? (children.length - 1 - i) : i
                this._focusSearch(children.item(index), options)
            }
            if (this.isBackward) this._focusSearchCheckNode(node, options)
        }

        document._focusSearchCheckNode = function(node, options)
        {
            if (options.isSearching && node.nodeName == 'INPUT' && (node.style.visibility != 'hidden'))
            {
                options.result = node;
                throw options;
            } else if (node == options.currentFocus)
            {
                options.isSearching = true
            }
        }

        function preventDefaultBehaviour(e)
        {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault)
                e.preventDefault();
            if (e.stopPropagation)
                e.stopPropagation();
        }
            
        function handlekeypress(cell,args,tableView,itemIndex,isLastColumn)
        {                      
            var e = args || window.event;          
            if (e.keyCode == 13)
            {
                //enter pressed
                if (isLastColumn == "True")
                {
                    preventDefaultBehaviour(e);
                    
                    var table = $find(tableView);
                    table.updateItem(itemIndex);
                }
                if (!e.which)
                {
                    e.keyCode = 9;
                }
                else
                {
                    document._focus = e.target;
                    document._moveFocus(false);

                    preventDefaultBehaviour(e);                               
                }
            }
            if (e.keyCode == 27)
            {
                //escape pressed
                preventDefaultBehaviour(e);

                //cancel update
                var table = $find(tableView);  
                table.cancelUpdate(itemIndex);
            }                     
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <telerik:RadScriptManager runat="server" ID="RadScriptManager1">
    </telerik:RadScriptManager>
    <div>      
        
        <telerik:RadAjaxPanel runat="server" >
        <telerik:RadGrid runat="server" ID="RadGrid1" AllowPaging="True" AllowAutomaticUpdates="true"
            DataSourceID="SqlDataSource1" GridLines="None"
            OnItemCreated="RadGrid1_ItemCreated">            
            <MasterTableView AutoGenerateColumns="False" DataKeyNames="CustomerID" 
                            DataSourceID="SqlDataSource1" EditMode="InPlace">
                <Columns>
                    <telerik:GridBoundColumn DataField="CustomerID" HeaderText="CustomerID" 
                        ReadOnly="True" SortExpression="CustomerID" UniqueName="CustomerID">
                    </telerik:GridBoundColumn>
                    <telerik:GridBoundColumn DataField="CompanyName" HeaderText="CompanyName" 
                        SortExpression="CompanyName" UniqueName="CompanyName">
                    </telerik:GridBoundColumn>
                    <telerik:GridBoundColumn DataField="ContactName" HeaderText="ContactName" 
                        SortExpression="ContactName" UniqueName="ContactName">
                    </telerik:GridBoundColumn>
                    <telerik:GridBoundColumn DataField="ContactTitle" HeaderText="ContactTitle" 
                        SortExpression="ContactTitle" UniqueName="ContactTitle">
                    </telerik:GridBoundColumn>
                    <telerik:GridEditCommandColumn></telerik:GridEditCommandColumn>
                </Columns>
            </MasterTableView>
        </telerik:RadGrid>
        
        </telerik:RadAjaxPanel>
        
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
            ConnectionString="<%$ ConnectionStrings:NorthwindConnectionString %>"             
            SelectCommand="SELECT [CustomerID], [CompanyName], [ContactName], [ContactTitle] FROM [Customers]" 
            UpdateCommand="UPDATE [Customers] SET [CompanyName] = @CompanyName, [ContactName] = @ContactName, [ContactTitle] = @ContactTitle WHERE [CustomerID] = @CustomerID">           
            <UpdateParameters>
                <asp:Parameter Name="CompanyName" Type="String" />
                <asp:Parameter Name="ContactName" Type="String" />
                <asp:Parameter Name="ContactTitle" Type="String" />
                <asp:Parameter Name="CustomerID" Type="String" />
            </UpdateParameters>            
        </asp:SqlDataSource>
    </div>
    </form>
</body>
</html>
